#include "InterfaceHeader.h"


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <check.h>

/*
 * 
 */


int compare_two_binary_files(FILE *fp1, FILE *fp2) {
    char ch1, ch2;
    int flag = 0;
    while (((ch1 = fgetc(fp1)) != EOF) &&((ch2 = fgetc(fp2)) != EOF)) {
        if (ch1 == ch2) {
            flag = 1;
            continue;
        }
        else {
            fseek(fp1, -1, SEEK_CUR);
            flag = 0;
            break;
        }
    }

    if ((fgetc(fp1) != EOF) || (fgetc(fp2) != EOF)) {
        flag = 0;
    }

    if (flag == 0) {
        return 1;
        //printf("Two files are not equal :  byte poistion at which two files differ is %d\n", ftell(fp1) + 1);

    } else {
        return 0;
        //printf("Two files are Equal\n ", ftell(fp1) + 1);
    }

}


START_TEST(test_1) {

	int TRANSPLANT_RESULT;
	TRANSPLANT_RESULT = GRAFT_INTERFACE(-1, NULL, NULL);

	//do not crash when the parameters are NULL

}

END_TEST


START_TEST(test_2) {
    //list archive contents
    FILE *fp;
    int stdout_bk; //is fd for stdout backup
    stdout_bk = dup(fileno(stdout));
    fp = fopen("temp.txt", "w");
    //file out, after read from file
    dup2(fileno(fp), fileno(stdout));
    /* ... */
    int TRANSPLANT_RESULT = GRAFT_INTERFACE ('t', "/home/alex/Development/GENERATING_RESULTS_FINAL_PROJ/ResultsGENTRANS/TransplantsWorkingFolder/TransplantCode/resultsOracle.tar", NULL);
    fflush(stdout); //flushall();
    fclose(fp);
    dup2(stdout_bk, fileno(stdout)); //restore
    FILE * outputFile = fopen("temp.txt", "r");
    char * line = (char *) malloc(1000 * sizeof (char));
    fgets(line, 4999, outputFile);
    if (strcmp("1 files in archive\n", line)) {
        ck_abort();
    }
    fgets(line, 4999, outputFile);
    if (!strstr(line, "Offset: 0	Length: 184	Name:") || !strstr(line, "FILE.in")) {
        ck_abort();
    }
}

END_TEST


START_TEST(test_3) {
    char * commandRemoveOldFile = "rm /home/alex/Development/GENERATING_RESULTS_FINAL_PROJ/ResultsGENTRANS/TransplantsWorkingFolder/TransplantCode/resultsFeatures.tar";
    system(commandRemoveOldFile);
    int TRANSPLANT_RESULT;
    TRANSPLANT_RESULT = GRAFT_INTERFACE ('c', "/home/alex/Development/GENERATING_RESULTS_FINAL_PROJ/ResultsGENTRANS/TransplantsWorkingFolder/TransplantCode/resultsFeatures.tar", "/home/alex/Development/GENERATING_RESULTS_FINAL_PROJ/ResultsGENTRANS/TransplantsWorkingFolder/TransplantCode/FILE.in");
    FILE * resultedFile = fopen("/home/alex/Development/GENERATING_RESULTS_FINAL_PROJ/ResultsGENTRANS/TransplantsWorkingFolder/TransplantCode/resultsFeatures.tar", "r");
    FILE * oracleFile = fopen("/home/alex/Development/GENERATING_RESULTS_FINAL_PROJ/ResultsGENTRANS/TransplantsWorkingFolder/TransplantCode/resultsOracle.tar", "r");
    if (compare_two_binary_files(resultedFile, oracleFile)) {
        ck_abort();
    }
}

END_TEST



START_TEST(test_4) {
    //append a file to an existing archive; we must first copy it in a new place
    //for not affecting the other test cases
    char * commandRemoveOldFile = "rm /home/alex/Development/GENERATING_RESULTS_FINAL_PROJ/ResultsGENTRANS/TransplantsWorkingFolder/TransplantCode/resultsFeatures.tar";
    system(commandRemoveOldFile);
    //copy the initial archive
    char * copyInitialArchive = "cp /home/alex/Development/GENERATING_RESULTS_FINAL_PROJ/ResultsGENTRANS/TransplantsWorkingFolder/TransplantCode/originalArchive.tar /home/alex/Development/GENERATING_RESULTS_FINAL_PROJ/ResultsGENTRANS/TransplantsWorkingFolder/TransplantCode/resultsFeatures.tar";
    system(copyInitialArchive);
    int TRANSPLANT_RESULT;
    TRANSPLANT_RESULT = GRAFT_INTERFACE ('a', "/home/alex/Development/GENERATING_RESULTS_FINAL_PROJ/ResultsGENTRANS/TransplantsWorkingFolder/TransplantCode/resultsFeatures.tar", "/home/alex/Development/GENERATING_RESULTS_FINAL_PROJ/ResultsGENTRANS/TransplantsWorkingFolder/TransplantCode/FILE.in");
    FILE * resultedFile = fopen("/home/alex/Development/GENERATING_RESULTS_FINAL_PROJ/ResultsGENTRANS/TransplantsWorkingFolder/TransplantCode/resultsFeatures.tar", "r");
    FILE * oracleFile = fopen("/home/alex/Development/GENERATING_RESULTS_FINAL_PROJ/ResultsGENTRANS/TransplantsWorkingFolder/TransplantCode/resultsOracle.tar", "r");
    if (compare_two_binary_files(resultedFile, oracleFile)) {
        ck_abort();
    }
}

END_TEST



Suite *
money_suite(void) {
    Suite *s = suite_create("GenTransSuite");
    // Core test case 
    TCase *tc_core = tcase_create("Core");
    tcase_add_test(tc_core, test_1);
    tcase_add_test(tc_core, test_2);
    tcase_add_test(tc_core, test_3);
    tcase_add_test(tc_core, test_4);
    suite_add_tcase(s, tc_core);
    return s;
}

int main(int argc, char** argv) {
    int number_failed;
    Suite *s = money_suite();
    SRunner *sr = srunner_create(s);
    srunner_run_all(sr, CK_SILENT);


    printf("\n\n");

    srunner_print(sr, CK_NORMAL);



    number_failed = srunner_ntests_failed(sr);
    srunner_free(sr);
    return (number_failed == 0) ? EXIT_SUCCESS : EXIT_FAILURE;
    //  return (EXIT_SUCCESS);
}
